﻿Imports System.Collections.ObjectModel
''' <summary>
''' ObservableCollection of Fields for display in WPF
''' </summary>
''' <remarks></remarks>
Public Class WorkflowFields
    Inherits ObservableCollection(Of WorkFlowField)
    ''' <summary>
    ''' Constructor
    ''' </summary>
    ''' <param name="data">Dictionary(Of String, String)</param>
    ''' <remarks>
    ''' Create the ObservableCollection from an input Dictionary
    ''' </remarks>
    Public Sub New(ByVal data As Dictionary(Of String, String))
        For Each Item As KeyValuePair(Of String, String) In data
            Me.Add(New WorkFlowField(Item))
        Next
    End Sub
    ''' <summary>
    ''' ContainsKey
    ''' </summary>
    ''' <param name="key">String</param>
    ''' <returns>Boolean</returns>
    ''' <remarks>Test for presence of a particular key</remarks>
    Public Function ContainsKey(ByVal key As String) As Boolean
        For Each item As WorkFlowField In Me.Items
            If item.Key = key Then Return True
        Next
        Return False
    End Function
    ''' <summary>
    ''' Item by key
    ''' </summary>
    ''' <param name="key"></param>
    ''' <returns>WorkFlowField</returns>
    ''' <remarks>
    ''' Return a WorflowField as if it was indexed by key
    ''' </remarks>
    Public Shadows Function Item(ByVal key As String) As WorkFlowField
        For Each Field As WorkFlowField In Me.Items
            If Field.Key = key Then Return Field
        Next
        Return Nothing
    End Function
End Class
''' <summary>
''' A Field class for display in WPF
''' </summary>
''' <remarks></remarks>
Public Class WorkFlowField
    Public Sub New(ByVal item As KeyValuePair(Of String, String))
        Me.Key = item.Key
        Me.Value = item.Value
    End Sub
    Property Key As String
    Property Value As String
End Class

