﻿Imports System.Activities
Public NotInheritable Class DataEntryActivity
    Inherits CodeActivity
    'Define Arguments
    Property Fields As InOutArgument(Of Dictionary(Of String, String))
    Property InputDocument As InArgument(Of String)
    Property OutputDocument As OutArgument(Of String)
    Private InputFields As Dictionary(Of String, String)
    Private InputDocumentName As String
    Private OutputDocumentName As String
    Private TargetActivityName As String
    ''' <summary>
    ''' --------------------------------------------------------------------------------------------
    ''' Get the data entry fields from the Input document
    ''' Input Document path comes from (in order of preference):
    '''   1. The "InputDocument" workflow property
    '''   2. A Field named InputDocument
    '''--------------------------------------------------------------------------------------------
    ''' </summary>
    ''' <param name="context"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub Execute(ByVal context As CodeActivityContext)
        InputDocumentName = InputDocument.Get(Of String)(context)
        OutputDocumentName = OutputDocument.Get(Of String)(context)
        ' Check for fields already filled in...
        InputFields = Fields.Get(Of Dictionary(Of String, String))(context)
        If InputFields IsNot Nothing AndAlso InputFields.Count >= 1 AndAlso InputFields.ContainsKey("InputDocument") Then
            If String.IsNullOrEmpty(InputDocumentName) Then InputDocumentName = InputFields("InputDocument")
        End If
        Dim DataEntryForm As New DataEntryWindow
        DataEntryForm.Document = InputDocumentName
        Dim Result = DataEntryForm.ShowDialog
        If Result IsNot Nothing AndAlso Result Then
            Me.Fields.Set(context, DataEntryForm.Fields)
        End If
    End Sub
End Class
